#!/bin/bash
source /etc/vdr.d/conf/gen2vdr.cfg

if [ "$(pidof vdr)" != "" ] ; then
   /etc/init.d/vdr stop
   RESTART=1
else
   RESTART=0
fi

/_config/bin/dvbmod unload

# check for ehd
EHD_DEV="1905:8100"
EHD="$(lspci -n | grep -c "$EHD_DEV")"

# check for ehd
[ $EHD -gt 0 ] && /_config/bin/g2v_setvdrversion.sh mp
   
/_config/bin/dvbmod check
/_config/bin/dvbmod load
echo "Waiting for dvb devices to register ..."
sleep 10
DVB_CARDS=$(ls -l /dev/dvb 2>/dev/null | grep adapter | wc -l)
if [ $DVB_CARDS -eq 0 -a $EHD -gt 0 ] ; then
   # check other mp driver
   cat /etc/vdr.d/conf/vdrdvb.version | sed -e "s/^#HG_MP/##HG_MP/"  -e "s/^HG_MP/#HG_MP/" -e "s/^##HG_MP/HG_MP/"
   /_config/bin/dvbmod unload
   rm /usr/local/src/VDR
   /_config/bin/g2v_setvdrversion.sh mp
   /_config/bin/dvbmod check
   /_config/bin/dvbmod load
   echo "Waiting for dvb devices to register ..."
   sleep 10
   DVB_CARDS=$(ls -l /dev/dvb 2>/dev/null | grep adapter | wc -l)
fi         

PRIM_DVB=$(ls -l /dev/dvb/*/osd* 2>/dev/null | wc -l)

EM84=$(sh /_config/bin/detect_modules.sh 2>/dev/null| grep "realmagic84xx")

#sh /_config/bin/detect_dxr3.sh
#DXR3=$?
GUI="VDR"

#$SETVAL "PLG_dxr3" "0"
$SETVAL "PLG_em84xx" "0"
#$SETVAL "PLG_xine" "0"
$SETVAL "PLG_xineliboutput" "0"
/_config/bin/g2v_setehd.sh 0
if [ "$PRIM_DVB" = "0" ] ; then    
   $SETVAL "DVB_RESET" "0"
else
   $SETVAL "DVB_RESET" "1"
fi   

ALSA=0

if [ $EHD -gt 0 ] ; then
   /_config/bin/g2v_setehd.sh 1
   [ -f /mnt/data/g2v-backup/.do_migrate ] && rm /mnt/data/g2v-backup/.do_migrate 
elif [ "$EM84" != "" ] ; then
   logger -s "EM84 detected - adding em84xx plugin"
   $SETVAL "PLG_em84xx" "3"
   $SETVAL "PLG_dvd" "0"
   $SETVAL GUI_SWITCH_OUTPUT 1
   $SETVAL GUI_LOOP_OUTPUT 0
   GUI="VDR_FreeVo"
#elif [ "$DXR3" = "1" ] ; then
#   logger -s "DXR3 detected - adding dxr3 plugin"
#   $SETVAL "PLG_dxr3" "3"
#   $SETVAL "PLG_dvd" "4"
elif [ "$PRIM_DVB" = "0" ] ; then    
   logger -s "No primary DVB card found - adding xineliboutput plugin"
   $SETVAL "PLG_xineliboutput" "3"   
   GUI="VDR_FreeVo"
   ALSA=1
fi

MEM=$(grep -i "memtotal" /proc/meminfo |sed -e "s/[^0-9]//g")
if [ $MEM -lt 200000 ] && [ $DVB_CARDS -gt 0 ] ; then
   GUI="VDR"
fi
$SETVAL GUI "$GUI"

IVTV=$(sh /_config/bin/detect_modules.sh 2>/dev/null| grep "^ivtv")
if [ "$IVTV" = "" ] ; then
   $SETVAL "PLG_pvrinput" "0"
else
   $SETVAL "PLG_pvrinput" "3"
fi   
if [ "$(grep "mp3ng.AudioOutMode" /etc/vdr/setup.conf)" != "" ] ; then
   sed -i /etc/vdr/setup.conf -e "s/^mp3ng\.AudioOutMode.*/mp3ng\.AudioOutMode = ${ALSA}/"
else
   echo "mp3ng.AudioOutMode = $ALSA" >> /etc/vdr/setup.conf
fi   
if [ "$(grep "mp3.AudioOutMode" /etc/vdr/setup.conf)" != "" ] ; then
   sed -i /etc/vdr/setup.conf -e "s/^mp3\.AudioOutMode.*/mp3\.AudioOutMode = ${ALSA}/"
else
   echo "mp3.AudioOutMode = $ALSA" >> /etc/vdr/setup.conf
fi   

$SETVAL "DVB_CARD_NUM" $DVB_CARDS
if [ "$RESTART" = "1" ] ; then
   /etc/init.d/vdr start
fi
