#!/bin/bash
#set -x
trap "" HUP INT QUIT TERM ABRT ALRM EXIT KILL STOP

source /_config/bin/strstr.sh
source /etc/vdr.d/conf/gen2vdr.cfg
source /etc/vdr.d/conf/vdr
source /_config/bin/g2v_splash.sh

#splash_setup
g2v_splash_exit
g2v_splash_start "shutdown"
g2v_splash_prog 100 100
g2v_splash_prog 100 100

touch /tmp/.shutdown
SPLASH_CON=$(fgconsole)
#sleep 3
# Module die NICHT entladen werden sollen
MOD_STAY="pcnet32"

# Boot-Services die gestoppt werden sollen
SVC_BOOT_STOP="alsasound lircd atd reel-ehd net.eth0"

# Default-Services die NICHT gestoppt werden sollen
SVC_DEF_STAY="hald dbus vixie-cron urandom keymaps ivman gpm consolefont acpid"

# Prozesse die beendet werden muessen
PROC_TO_KILL="vdr-disable.sh vdr-enable.sh X ntpdate umount mount vdr X perl /usr/bin/perl"

# Services die zuerst/zuletzt beendet/gestartet werden
SVC_STOP_FIRST="local vdr freevo xvdr"
SVC_STOP_LAST="lircd"
SVC_START_FIRST="reel-ehd lircd vdr freevo xvdr net.eth0"
SVC_START_LAST="local"

if [ "$LIRC" != "Tastatur" ] ; then
   SVC_START_FIRST="lircd vdr"
else
   SVC_START_FIRST="vdr"   
fi      
[ "$GUI" = "VDR" ] && SVC_START_FIRST="$SVC_START_FIRST xvdr"
[ "$GUI" = "VDR_FreeVo" -o "$GUI" = "FreeVo" ] && SVC_START_FIRST="$SVC_START_FIRST freevo"
[ "$NET" = "Ja" ] && SVC_START_FIRST="$SVC_START_FIRST net.eth0"

# In /etc/conf.d/myhibernate.conf koennen diese Parameter umgestellt werden - VORSICHT !!!

[ -f /etc/conf.d/myhibernate.conf ] && source /etc/conf.d/myhibernate.conf
#svdrpsend.pl MESG "System wird heruntergefahren ..."

#logout all users
skill -KILL -v /dev/pts/*

SVC_STARTED="$(rc-status -nc -a |grep " started "|cut -f 2 -d " " | tr "\n" " ")"
SVC_BOOT="$(rc-status -nc boot |grep " started "|cut -f 2 -d " " | tr "\n" " ")"
logger -s "Running services: <$SVC_STARTED>"

#SVC_START_SEQ="$SVC_START_FIRST"
SVC_START_SEQ="$SVC_START_FIRST"
SVC_STOP_SEQ="$SVC_STOP_FIRST"

# is freevo the master ?
#if ( strstr " $PLUGINS " " xine" ) ||  
#   ( ( strstr " $PLUGINS " " em84xx " ) && [ "$ACTIVY_OVERLAY" != "Aus" ] ) ; then
#   SVC_STOP_LAST="vdr gui $SVC_STOP_LAST"
#else
#   SVC_STOP_LAST="gui vdr $SVC_STOP_LAST"
#fi

# calculate services to stop
for i in $SVC_STARTED ; do
   if ( ! strstr " $SVC_BOOT $SVC_DEF_STAY $SVC_STOP_SEQ $SVC_STOP_LAST " " $i " ) ; then
      SVC_STOP_SEQ="$SVC_STOP_SEQ $i"
   fi
done

for i in $SVC_BOOT_STOP ; do
   if ( ! strstr " $SVC_STOP_SEQ $SVC_STOP_LAST " " $i " ) ; then
      SVC_STOP_SEQ="$SVC_STOP_SEQ $i"
   fi
done

for i in $SVC_STOP_LAST ; do
   if ( ! strstr " $SVC_STARTED " " $i " ) ; then
      SVC_STOP_SEQ="$SVC_STOP_SEQ $i"
   fi
done
if [ "$WAKEONLAN" = "1" ] ; then
   ethtool -s eth0 wol g
   if (grep PCI0 /proc/acpi/wakeup | grep disabled 2>&1 >> /dev/null) ; then
     echo -n PCI0 > /proc/acpi/wakeup
   fi
fi
	       

logger -s "Services to stop: <$SVC_STOP_SEQ>"
NUM_SVC=$(echo $SVC_STOP_SEQ | wc -w)
NUM_STEPS=$(($NUM_SVC + 5))
IDX=$NUM_STEPS

for i in $SVC_STOP_SEQ ; do
   CON=$(fgconsole)
   logger -s "Stopping >$i< >$CON<"
   IDX=$(($IDX - 1))
   g2v_splash_prog $IDX $NUM_STEPS $i
   /etc/init.d/$i stop
   /etc/init.d/$i zap
   [ "$CON" != "$SPLASH_CON" ] && killall -9 chvt && chvt $SPLASH_CON && logger -s "Switch Console"
done

SVC_ALIVE="$(rc-status -nc -a |grep " started "|cut -f 2 -d " " | tr "\n" " ")"

# Now calculate startup sequence
logger -s "Still running >$SVC_ALIVE<"

for i in $SVC_START_FIRST $SVC_BOOT $SVC_STARTED ; do
   if ( ! strstr " $SVC_START_SEQ $SVC_START_LAST $SVC_ALIVE " " $i " ) &&
        ( strstr " $SVC_STARTED " " $i ") ; then 
      SVC_START_SEQ="$SVC_START_SEQ $i"
   fi
done
for i in $SVC_START_LAST ; do
   if ( ! strstr " $SVC_ALIVE $SVC_START_SEQ " " $i " ) ; then
      SVC_START_SEQ="$SVC_START_SEQ $i"
   fi
done
if [ "$WAKEONLAN" = "1" ] ; then
   ethtool -s eth0 wol g
   if (grep PCI0 /proc/acpi/wakeup | grep disabled 2>&1 >> /dev/null) ; then
     echo -n PCI0 > /proc/acpi/wakeup
   fi
fi

logger -s "Services to start: <$SVC_START_SEQ>"

g2v_splash_prog 2 $NUM_STEPS

#sleep 3
/_config/bin/dvbmod unload > /dev/null 2>&1

g2v_splash_prog 1 $NUM_STEPS

/_config/bin/activy_lcdoff.sh

MOD_LOAD="$(lsmod |cut -f 1 -d " " |grep -v "Module")"
for i in $MOD_LOAD ; do
   if ( ! strstr " $MOD_STAY " " $i " ) ; then
      logger -s "Unloading $i"
      modprobe -r $i
   fi
done

# Cleanup !
rm /tmp/.*
killall -9 $PROC_TO_KILL > /dev/null 2>&1

g2v_splash_prog 0 $NUM_STEPS
NUM_STEPS=$(($(echo "$SVC_START_FIRST" | wc -w) + 3 ))

STILL_LOADED="$(lsmod | cut -f 1 -d " " | tr "\n" " ")"
logger -s "Still loaded <$STILL_LOADED>"
ps x |logger
g2v_splash_exit
if [ "$AFP_WATCHDOG" != "" -a "$AFP_WATCHDOG" != "0" ] ; then
   afp-tool -h $(($AFP_WATCHDOG + 3))
fi
	       
logger -s "Hibernating $SHUTDOWN_METHOD ..."
#echo mem > /sys/power/state
if [ "${SHUTDOWN_METHOD}" = "STR" ] ; then
   echo mem > /sys/power/state
elif [ "${SHUTDOWN_METHOD}" = "STD1" ] ; then   
   echo shutdown > /sys/power/disk
   echo disk > /sys/power/state
else
   echo platform > /sys/power/disk
   echo disk > /sys/power/state
fi

afp-tool -h 0
afp-tool -a 0 -t "Gen2VDR startet|..."
logger -s "Wieder da ..."
g2v_splash_start "bootup"
g2v_splash_prog 1 $NUM_STEPS
SPLASH_CON=$(fgconsole)
/etc/init.d/modules zap
/etc/init.d/modules start

for i in $MOD_LOAD ; do
   logger -s "Loading $i"
   modprobe $i
done
g2v_splash_prog 2 $NUM_STEPS
/_config/bin/dvbmod load

g2v_splash_prog 3 $NUM_STEPS

IDX=4
echo "Starting >$SVC_START_SEQ<"
DONE=""
for i in $SVC_START_SEQ ; do
    if [ "$DONE" = "" ] ; then
       if ( ! strstr " $SVC_START_FIRST " " $i " ) ; then
          DONE=1
          logger -s "Waiting before Starting <$i>"
          sleep 15
       else
          [ "$CON" != "$SPLASH_CON" ] && killall -9 chvt && chvt $SPLASH_CON && logger -s "Switch Console"
       fi	  
    fi
    logger -s "Starting $i"
    if [ "$DONE" = "" ] ; then
       /etc/init.d/$i start
    else
       screen -dm sh -c "/etc/init.d/$i start"
    fi   
    g2v_splash_prog $IDX $NUM_STEPS
    IDX=$(($IDX + 1))
done
g2v_splash_exit
[ "$(fgconsole)" = "16" ] && chvt 1
trap - HUP INT QUIT TERM ABRT ALRM EXIT KILL STOP
