#!/bin/bash
export DISPLAY=:0

#OM="mini42.jad"
OM="opera-mini-4.2.13216-advanced-de.jad"
source /etc/vdr.d/conf/vdr
nl='
'
#set -x
if [ "${SCREEN_RESOLUTION}" = "Manuell" ] ; then
   SCREEN_RESOLUTION=$(grep -i geometry /etc/freevo/freevo.conf | cut -f2 -d "=")
fi

if [ ! -d /mnt/data/download/C ] ; then
   sudo mkdir -p /mnt/data/download/C /mnt/data/download/E
   sudo chown -R vdr:users /mnt/data/download
fi
      
XRES=${SCREEN_RESOLUTION%x*}
YRES=${SCREEN_RESOLUTION#*x}

WIDTH=$(($XRES - $FREEVO_OSDLEFT - $FREEVO_OSDRIGHT))
HEIGHT=$(($YRES - $FREEVO_OSDTOP - $FREEVO_OSDBOTTOM))
[ $HEIGHT -gt $(($YRES - 40)) ] && HEIGHT=$(($YRES - 40))
      
RECT=0
MAIN=0

mv /home/vdr/.microemulator/config2.xml /home/vdr/.microemulator/config2.xml.org
oldIFS=$IFS
IFS=$nl
			     
cat /home/vdr/.microemulator/config2.xml.org | while read line ; do
   case $line in
     *\<rectangle\>*) 
       RECT=1
       ;;
     *\</rectangle\>*) 
       RECT=0
       ;;
     *\<main\ *) 
       MAIN=1
       ;;
     *\</main\>*) 
       MAIN=0
       ;;
     *\<x\>*)
       if [ "$RECT" = "1" ] ; then
          X=0
       else
          X=$FREEVO_OSDLEFT
       fi
       line="${line%%>*}>$X</x>"
       ;;
     *\<y\>*)
       if [ "$RECT" = "1" ] ; then
          Y=0
       else
          if [ $FREEVO_OSDTOP -gt 20 ] ; then
             Y=$(($FREEVO_OSDTOP - 20))
          else
             Y=0
          fi
       fi
       line="${line%%>*}>$Y</y>"
       ;;
     *\<width\>*)
       line="${line%%>*}>$WIDTH</width>"
       ;;
     *\<height\>*)
       if [ "$RECT" = "1" ] ; then
          HGT=$HEIGHT
       else
          HGT=$(($HEIGHT + 40))
       fi
       line="${line%%>*}>$HGT</height>"
       ;;
     *http.proxyHost*)   
       line="${line%%=\"*}=\"$PROXY_HOST\" NAME${line#*\" NAME}"
       ;;	 
     *http.proxyPort*)   
       line="${line%%=\"*}=\"$PROXY_PORT\" NAME${line#*\" NAME}"
       ;;
     *)	 
       ;;
   esac
echo "$line"
done > /home/vdr/.microemulator/config2.xml
IFS=$oldIFS

key2xd /_config/freevo/operamini.key2x &

# Stop irexec because Activy FB uses some Hotkeys
if [ "$(pidof irexec)" != "" ] ; then
   sudo /etc/init.d/irexec stop
   START_IREXEC=1
else   
   START_IREXEC=0
fi

rm /tmp/om.log >/dev/null 2>&1
java -cp /usr/share/microemulator-bin/lib/microemulator.jar:/usr/share/microemulator-bin/lib/microemu-jsr-75.jar org.microemu.app.Main \
     --impl org.microemu.cldc.file.FileSystem org.microemu.examples.fcview.FCViewMIDlet /opt/opera-mini/$OM >/tmp/om.log 2>&1 &

for i in $(seq 1 30) ; do
   ct=$(grep -c "^openJar url" /tmp/om.log)
   if [ $ct -eq 1 ] ; then
      xte "key Return"
   elif [ $ct -gt 1 ] ; then
      break      
   fi
   sleep 1
done

while [ "$(ps x | grep "java \-cp /usr/share/microemulator-bin/lib/microemulator.jar")" != "" ] ; do
   sleep 3
done
   
killall -9 key2xd
[ "$START_IREXEC" = "1" ] && sudo /etc/init.d/irexec start
